import numpy as np
import pandas as pd
import pytest
from deepdiff import DeepDiff
from parallel_bilby.analysis import analysis_run
from parallel_bilby.analysis.sample_space import fill_sample
from tests.cases import FastRun


class SampleSpaceTest(FastRun):
    def setUp(self):
        super().setUp()
        self.run = analysis_run.AnalysisRun(**self.analysis_args)

    @pytest.mark.mpi_skip
    def test_fill_sample(self):
        """
        Generate a sample using the fill_sample function, and compare to
        reference values.
        """
        ii = 0
        row = pd.Series(
            dict(
                chirp_mass=28.005628,
                log_likelihood=878.837994,
                log_prior=0,
                mass_ratio=1.0,
                a_1=0.6,
                a_2=0.6,
                tilt_1=0.0,
                tilt_2=0.0,
                phi_12=0.0,
                phi_jl=0.0,
                luminosity_distance=800.0,
                dec=0.1,
                ra=0.1,
                theta_jn=0.1,
                psi=0.1,
                phase=0.1,
                geocent_time=0.0,
            )
        )

        sample = fill_sample((ii, row, self.run.likelihood))
        reference_sample = {
            "mass_ratio": 1.0,
            "a_1": 0.0,
            "a_2": 0.0,
            "tilt_1": 0.0,
            "tilt_2": 0.0,
            "phi_12": 0.0,
            "phi_jl": 0.0,
            "luminosity_distance": 1000.0,
            "dec": 0.0,
            "ra": 0.0,
            "theta_jn": 0.0,
            "psi": 0.0,
            "phase": 0.0,
            "geocent_time": 0.0,
            "chirp_mass": 28.005,
            "log_likelihood": 878.837,
            "log_prior": 0.0,
            "H1_matched_filter_snr": 26.9659 - 0.09616j,
            "H1_optimal_snr": 26.970,
            "reference_frequency": 20.0,
            "waveform_approximant": "IMRPhenomPv2",
            "minimum_frequency": 20.0,
            "maximum_frequency": 2048.0,
            "catch_waveform_errors": True,
            "pn_spin_order": -1,
            "pn_tidal_order": -1,
            "pn_phase_order": -1,
            "pn_amplitude_order": 0,
            "mode_array": None,
            "total_mass": 64.34,
            "mass_1": 32.17,
            "mass_2": 32.17,
            "symmetric_mass_ratio": 0.25,
            "iota": np.array(0.0),
            "spin_1x": np.array(0),
            "spin_1y": np.array(0),
            "spin_1z": np.array(0.0),
            "spin_2x": np.array(0),
            "spin_2y": np.array(0),
            "spin_2z": np.array(0.0),
            "phi_1": 0.0,
            "phi_2": 0.0,
            "chi_eff": 0.0,
            "chi_1_in_plane": 0.0,
            "chi_2_in_plane": 0.0,
            "chi_p": 0.0,
            "cos_tilt_1": 1.0,
            "cos_tilt_2": 1.0,
            "redshift": 0.198,
            "comoving_distance": 834.74,
            "mass_1_source": 26.85,
            "mass_2_source": 26.85,
            "chirp_mass_source": 23.37,
            "total_mass_source": 53.7,
        }

        bad_types = [np.ndarray, np.complex128, complex]
        sample_diff = DeepDiff(
            sample,
            reference_sample,
            number_format_notation="e",
            significant_digits=1,
            ignore_numeric_type_changes=True,
            exclude_types=bad_types,
        )
        self.assertEqual(
            {},
            sample_diff,
            msg=f"The sample generated by fill_sample is not as expected. The difference is: {sample_diff}",
        )

        # Numpy comparison for 0-d arrays/complex numbers does not work with DeepDiff
        # Handle them separately.
        for key in reference_sample:
            if type(reference_sample[key]) in bad_types:
                assert reference_sample[key] == pytest.approx(sample[key], abs=1e-1)
